<?php
# -- BEGIN LICENSE BLOCK ----------------------------------
#
# This file is part of LiTraAk Plugin for Dotclear 2.
# 
# Copyright (c) 2008 Akewea.com
# 
# LiTraAk Plugin for Dotclear 2 is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# LiTraAk Plugin for Dotclear 2 is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with LiTraAk Plugin for Dotclear 2.  If not, see <http://www.gnu.org/licenses/>.
#
# -- END LICENSE BLOCK ------------------------------------

class litraakFeeds extends dcUrlHandlers
{

	static $FEED_TYPES = array('rss2', 'atom');
	static $GLOBAL_FEED_TYPES = array('tickets', 'releases', 'projects');
	static $PROJECT_FEED_TYPES = array('tickets', 'releases');

	public static function litraakGlobalFeeds($path_items, $args)
	{
		if(count($path_items) == 3 && $path_items[0] == 'feed'){

			if(		in_array($path_items[1], self::$FEED_TYPES)
			&& in_array($path_items[2], self::$GLOBAL_FEED_TYPES)){
				switch($path_items[2]){
					case 'tickets': self::litraakTicketsFeed(null, $path_items[1]); exit;
					case 'releases': self::litraakMilestonesFeed(null, $path_items[1]); exit;
					case 'projects': self::litraakProjectsFeed($path_items[1]); exit;
				}
			}
		}

		self::p404();
		exit;
	}

	public static function litraakProjectFeeds($project, $path_items, $args)
	{
		if(count($path_items) == 4 && $path_items[1] == 'feed'){

			if(		in_array($path_items[2], self::$FEED_TYPES)
			&& in_array($path_items[3], self::$PROJECT_FEED_TYPES)){
				switch($path_items[3]){
					case 'tickets': self::litraakTicketsFeed($project, $path_items[2]); exit;
					case 'releases': self::litraakMilestonesFeed($project, $path_items[2]); exit;
				}
			}

			self::p404();
			exit;
		}
	}

	protected static function litraakProjectsFeed($type='rss2')
	{
		global $_ctx;
		global $core;

		$_ctx->nb_entry_per_page = $core->blog->settings->litraak_nb_projects_per_feed;

		self::litraakServeFeed('projects', $type);
	}

	protected static function litraakTicketsFeed($project, $type='rss2')
	{
		global $_ctx;
		global $core;

		if($project != null){
			$_ctx->posts = $project;
		}
		
		$_ctx->nb_tickets_per_page = $core->blog->settings->litraak_nb_tickets_per_feed;

		self::litraakServeFeed('tickets', $type);
	}

	protected static function litraakMilestonesFeed($project, $type='rss2')
	{
		global $_ctx;
		global $core;

		if($project != null){
			$_ctx->posts = $project;
		}
		
		$_ctx->nb_milestones_per_page = $core->blog->settings->litraak_nb_milestones_per_feed;

		self::litraakServeFeed('milestones', $type);
	}

	protected static function litraakServeFeed($tpl, $type='rss2')
	{
		global $core;

		$mime = 'application/xml';
		if($type == 'atom'){
			$mime = 'application/atom+xml';
		}

		header('X-Robots-Tag: '.context::robotsPolicy($core->blog->settings->robots_policy,''));
		$core->tpl->setPath($core->tpl->getPath(), dirname(__FILE__).'/../default-templates');
		self::serveDocument('litraak-'.$type.'-'.$tpl.'.xml', $mime);
		exit;
	}
}
?>